Subject: Re: [PATCH] t7700: demonstrate mishandling of objects in packs with a .keep file

From: Andreas Ericsson <[email-masked]>
Date: Tue, 04 Nov 2008 20:25:44 +0100

Brandon Casey wrote:
> Andreas Ericsson wrote:
> 
>> So long as "git repack -a" still creates a mega-pack, I'm fine with
>> whatever.
> 
> I don't think it will after pack-objects is taught about .keep files, and

In that case you're almost certainly breaking something.

> I don't think it will _now_ if all of your packs have .keep files.
> 

It should, by copying the objects from the .keep-marked packfiles. Otherwise
either repack or the repack docs are in error.

> 'repack -a' will call pack-objects with either '--unpack=<packfile>' for
> each pack file without a .keep file, or with '--unpacked --incremental' if
> there are no pack files without .keep files.
> 
> In the first case, the modifications to pack-objects that I propose
> will prevent objects that exist in local packs with .keep files
> from being packed into the new pack.
> 
> In the second case, the --incremental option would have done the same thing.
> 
> So this inconsistency already existed, but will now be removed in favor of
> honoring .keep files.
> 

That means the nifty hack of incrementally and sometimes fully repack the
odb to speed up cloning over dumb protocols no longer works properly, then.

-- 
Andreas Ericsson                   [email-masked]
OP5 AB                             www.op5.se
Tel: +46 8-230225                  Fax: +46 8-230231